// OnTime.cpp : Defines the class behaviors for the application.
//
// Copyright 2005 BIGBROTHER All rights reserved
// Park,JeiSeog  jeiseog@yahoo.co.kr
//
//	Discriptions of Revision
//  =================================================================
//  2005.08.03 jspark α׷ ʱۼ
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "OnTime.h"

#include "MainFrm.h"

#include "OnTimeDoc.h"
#include "OnTimeView.h"
#include "Notify.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COnTimeApp

BEGIN_MESSAGE_MAP(COnTimeApp, CWinApp)
	//{{AFX_MSG_MAP(COnTimeApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COnTimeApp construction

COnTimeApp::COnTimeApp()
	: CWinApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_bOClock			= TRUE;
	m_bSleep			= FALSE;
	m_bTestMode			= FALSE;
	m_nSleepTimeFrom	= 21;
	m_nSleepTimeTo		= 6;
	m_csSoundPath		= _T("");
	m_bHighVolume		= FALSE;
	m_bMannerModeApply	= FALSE;
	m_bMute				= FALSE;
	m_bLogMode			= FALSE;
	m_bPowerDown		= FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only COnTimeApp object

COnTimeApp	theApp;
HANDLE		g_hNotificationHandle = 0;

/////////////////////////////////////////////////////////////////////////////
// COnTimeApp initialization

void GwesPowerOffSystem(void);

BOOL COnTimeApp::InitInstance()
{
	readInitValue();

	if (wcslen(this->m_lpCmdLine) > 0)
	{
		BOOL bWakeUp = FALSE;
		CTime time(CTime::GetCurrentTime());
		int nSeconds = time.GetSecond();
		if ( nSeconds >= 3 && nSeconds <= 10) 
			bWakeUp = TRUE;

		writeLog("bAuto=TRUE");
		this->m_lpCmdLine[0] = '\0';
		if (m_bOClock == TRUE) 
		{
			playSound();
			setNextEvent(TRUE);
		}
		if (bWakeUp == TRUE && m_bPowerDown == TRUE)
		{
			//GwesPowerOffSystem();
			keybd_event (VK_OFF, 0, KEYEVENTF_SILENT, 0);
			keybd_event (VK_OFF, 0, KEYEVENTF_SILENT | KEYEVENTF_KEYUP, 0);

		}
		return FALSE;
	}
	else
	{
		writeLog("bAuto=FALSE");
	}
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(COnTimeDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(COnTimeView));
	AddDocTemplate(pDocTemplate);
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
	{
		writeLog("!ProcessShellCommand(cmdInfo)");
		return FALSE;
	}
	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

void COnTimeApp::setNextEvent(BOOL bEventedCleared)
{
	// н Ѵ.
	TCHAR szExePath[MAX_PATH+2];
	GetModuleFileName(AfxGetInstanceHandle(), szExePath, sizeof (szExePath));

	if (m_bOClock == FALSE)
	{
		if (bEventedCleared == FALSE && g_hNotificationHandle != 0)
			CeClearUserNotification(g_hNotificationHandle);

		writeLog("setNextEvent m_bOClock == FALSE");
		g_hNotificationHandle = 0;
		writeInitValue();
		return;
	}

	CTime time(CTime::GetCurrentTime());
	CTimeSpan span;

	if (m_bTestMode == TRUE)
	{
		CTimeSpan ts(0, 0, 1, 0);
		span = ts;
		if (time.GetSecond() >= 50)
			span += ts;
	}
	else
	{
		CTimeSpan ts(0, 1, 0, 0);
		span = ts;
		// ̺Ʈ ߻ϱ 10ʿ Ǵ  ٷ ̺Ʈ ߻Ǿ شð  ݺǹǷ
		// +1 ̺Ʈð ű. 
		if (time.GetMinute() == 59 && time.GetSecond() >= 50)
			span += ts;
	}
	time += span;
	SYSTEMTIME stNextTime;
	time.GetAsSystemTime(stNextTime);
	stNextTime.wMilliseconds = 0;
	stNextTime.wSecond		 = 0;
	if (m_bTestMode == FALSE)
		stNextTime.wMinute	 = 0;

	CE_NOTIFICATION_TRIGGER nt;
	memset (&nt, 0, sizeof (CE_NOTIFICATION_TRIGGER));
	nt.dwSize = sizeof (CE_NOTIFICATION_TRIGGER);
	nt.dwType = CNT_TIME; 
	nt.lpszApplication = szExePath;
	nt.lpszArguments = _T("AUTO");

	nt.stStartTime = stNextTime;
	HANDLE hNotificationHandle;
	
	if (bEventedCleared == FALSE)
	{
		// ̺Ʈ ⸦ Ѵ.
		hNotificationHandle = CeSetUserNotificationEx (g_hNotificationHandle, &nt, NULL);
		//   ٽ ̺Ʈ ߰ϵ Ѵ.
		if (hNotificationHandle == 0) 
			hNotificationHandle = CeSetUserNotificationEx (0, &nt, NULL);
	}
	else
	{
		// ̺Ʈ ߰Ѵ.
		hNotificationHandle = CeSetUserNotificationEx (0, &nt, NULL);
	}
	g_hNotificationHandle = hNotificationHandle;
	writeInitValue();
	char szMsg[512];
	sprintf(szMsg, "CeSetUserNotificationEx('20%02d.%02d.%02d %02d:%02d:%02d') = %s",
		//szExePath,
		stNextTime.wYear%100, stNextTime.wMonth+1, stNextTime.wDay, stNextTime.wHour, stNextTime.wMinute, stNextTime.wSecond, 
		(hNotificationHandle != NULL) ? "TRUE" : "FALSE");
	writeLog(szMsg);
}


void COnTimeApp::playSound()
{
	if (m_bMannerModeApply == TRUE && m_bMute == TRUE)
	{
		writeLog("m_bMannerModeApply == TRUE && m_bMute == TRUE");
		return;
	}
	CTime time(CTime::GetCurrentTime());
	int nHour = 0, nHour24 = 0;
	if (m_bTestMode == TRUE)
	{
		nHour = time.GetMinute() % 10;
		if (nHour == 0) nHour = 10;
		nHour24 = time.GetMinute() % 20;
		if (nHour24 == 0) nHour24 = 20;
	}
	else
	{
		tm *t_tm = time.GetLocalTm();
		nHour = t_tm->tm_hour % 12;
		if (nHour == 0) nHour = 12;
		nHour24 = t_tm->tm_hour;
	}

	DWORD dwVolume = -1;
	if (m_bHighVolume == TRUE)
	{
		if (waveOutGetVolume((HWAVEOUT)WAVE_MAPPER, &dwVolume) == MMSYSERR_NOERROR)
		{
			if (waveOutSetVolume((HWAVEOUT)WAVE_MAPPER, 0xFFFF)== MMSYSERR_NOERROR)
				writeLog("waveOutSetVolume() SUCCESS");
		}

	}

	// SOUND Path Ѵ.
	TCHAR szSoundPath[MAX_PATH+2];
    wsprintf(szSoundPath, _T("%s%dh.wav"), m_csSoundPath, nHour); 

	while (TRUE)
	{
		if (m_bSleep == TRUE && isSoundTime(nHour24) == FALSE)
		{
			writeLog("m_bSleep == TRUE && isSoundTime(nHour24) == FALSE");
			break;
		}
		if (m_bTestMode == TRUE)
		{
			if (PlaySound (szSoundPath, NULL, SND_SYNC | SND_NODEFAULT | SND_NOSTOP) == FALSE)
				writeLog("m_bTestMode == TRUE, PlaySound FAIL");
			else
				writeLog("m_bTestMode == TRUE, PlaySound SUCESS");
		}
		else
		{
			if (time.GetMinute() != 0 && time.GetMinute() != 59) 
			{
				writeLog("time.GetMinute() != 0");
				break;
			}
			if (PlaySound (szSoundPath, NULL, SND_SYNC | SND_NODEFAULT | SND_NOSTOP) == FALSE)
				writeLog("m_bTestMode == FALSE, PlaySound FAIL");
			else
				writeLog("m_bTestMode == FALSE, PlaySound SUCESS");
		}
		break;
	}
	if (dwVolume != -1)
		waveOutSetVolume((HWAVEOUT)WAVE_MAPPER, dwVolume);

}

//  о´.
void COnTimeApp::readInitValue()
{
	HKEY hKey;
	DWORD dwData, dwLen = sizeof(dwData);

	TCHAR szExePath[MAX_PATH+2];
	GetModuleFileName(AfxGetInstanceHandle(), szExePath, sizeof (szExePath));
	CString csPath;
	csPath = szExePath;
	csPath.Replace(_T("OnTime.exe"), _T(""));
	m_csSoundPath = csPath;

	csPath = szExePath;
	csPath.Replace(_T("OnTime.exe"), _T("OnTimeLog.txt"));
	m_csLogFile = csPath;
	
	if (RegOpenKeyEx( HKEY_LOCAL_MACHINE, _T("Software\\BigBrother\\OnTime"), 0, 0, &hKey) != ERROR_SUCCESS)
		return;

	if (RegQueryValueEx(hKey, _T("OCLOCK_BOOL"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bOClock = TRUE;
		else				m_bOClock = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("SLEEP_MODE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bSleep = TRUE;
		else				m_bSleep = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("TEST_MODE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bTestMode = TRUE;
		else				m_bTestMode = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("LOG_MODE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bLogMode = TRUE;
		else				m_bLogMode = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("POWER_DOWN"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bPowerDown = TRUE;
		else				m_bPowerDown = FALSE;
	}

	if (RegQueryValueEx(hKey, _T("NOTI_HANDLE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
		g_hNotificationHandle = (HANDLE)dwData;

	if (RegQueryValueEx(hKey, _T("HIGH_VOLUME"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bHighVolume = TRUE;
		else				m_bHighVolume = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("MANNER_MODE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bMannerModeApply = TRUE;
		else				m_bMannerModeApply = FALSE;
	}

	if (RegQueryValueEx(hKey, _T("SLEEP_TIME_FROM"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
		m_nSleepTimeFrom = dwData;
	if (RegQueryValueEx(hKey, _T("SLEEP_TIME_TO"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
		m_nSleepTimeTo = dwData;

	RegCloseKey(hKey);

	if (RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\HP\\UI\\CallMgr"), 0, 0, &hKey) != ERROR_SUCCESS)
	{
		if (RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\LGE\\UI\\CallMgr"), 0, 0, &hKey) != ERROR_SUCCESS)
			return;
	}
	if (RegQueryValueEx(hKey, _T("CallStatus"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if ((dwData & 0x02) == 0x02) // ųʸ
			m_bMute = TRUE;
		else
			m_bMute = FALSE;
	}
	RegCloseKey(hKey);

}

void COnTimeApp::writeInitValue()
{
	HKEY hKey         = 0;
	DWORD dwData      = (DWORD)g_hNotificationHandle;
	DWORD dwLastError = 0; 	

	dwLastError = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\BigBrother\\OnTime"), 0, 0, &hKey);
	if (dwLastError != ERROR_SUCCESS)
	{
		 dwLastError = RegCreateKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\BigBrother\\OnTime"), 0, NULL, 
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL);
	}
	if (dwLastError != ERROR_SUCCESS)
	{
		AfxMessageBox(_T("   ϴ.")); 
		return;
	}
	RegSetValueEx(hKey, _T("NOTI_HANDLE"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));
	RegCloseKey(hKey);
}

BOOL COnTimeApp::isSoundTime(int nHour)
{
	nHour--;
	if (m_nSleepTimeFrom <= m_nSleepTimeTo)
	{
		if (m_nSleepTimeFrom <= nHour && nHour <= m_nSleepTimeTo)
			return FALSE;
	}
	else 
	{
		if (m_nSleepTimeFrom <= nHour || nHour <= m_nSleepTimeTo)
			return FALSE;
	}
    return TRUE;
}

void COnTimeApp::writeLog(char *pszMsg)
{
	if (m_bLogMode == FALSE) return;

	CFile f;
	CFileException e;
	if( !f.Open(m_csLogFile, CFile::modeReadWrite, &e ) )
	{
		if ( !f.Open(m_csLogFile, CFile::modeCreate | CFile::modeWrite, &e))
		{
			#ifdef _DEBUG
				afxDump << "File could not be opened " << e.m_cause << "\n";
			#endif
			return;
		}
	}
	f.SeekToEnd();

	CTime time(CTime::GetCurrentTime());
	tm *t_tm = time.GetLocalTm();

	char szMsg[512];
	sprintf(szMsg, "20%02d.%02d.%02d %02d:%02d:%02d - %s\r\n",
		t_tm->tm_year%100, t_tm->tm_mon+1, t_tm->tm_mday, t_tm->tm_hour, t_tm->tm_min, t_tm->tm_sec, pszMsg);
	f.Write(szMsg, strlen(szMsg));
    f.Close();
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();		// Added for WCE apps
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void COnTimeApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// COnTimeApp commands
// Added for WCE apps

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CenterWindow();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
