// OnTimeView.cpp : implementation of the COnTimeView class
//
// Copyright 2005 BIGBROTHER All rights reserved
// Park,JeiSeog  jeiseog@yahoo.co.kr
//
//	Discriptions of Revision
//  =================================================================
//  2005.08.03 jspark α׷ ʱۼ
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OnTime.h"

#include "OnTimeDoc.h"
#include "OnTimeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COnTimeView

IMPLEMENT_DYNCREATE(COnTimeView, CFormView)

BEGIN_MESSAGE_MAP(COnTimeView, CFormView)
	//{{AFX_MSG_MAP(COnTimeView)
	ON_BN_CLICKED(IDC_BUTTON_SET, OnButtonSet)
	ON_BN_CLICKED(IDC_BUTTON_QUIT, OnButtonQuit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COnTimeView construction/destruction

COnTimeView::COnTimeView()
	: CFormView(COnTimeView::IDD)
{
	//{{AFX_DATA_INIT(COnTimeView)
	m_bOClock        = TRUE;
	m_bSleep         = FALSE;
	m_bTestMode      = FALSE;
	m_nSleepTimeFrom = 21;
	m_nSleepTimeTo   = 6;
	m_bHighVolume    = FALSE;
	m_bMannerModeApply = FALSE;
	m_bLogMode = FALSE;
	m_bPowerDown = FALSE;
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

COnTimeView::~COnTimeView()
{
}

void COnTimeView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COnTimeView)
	DDX_Check(pDX, IDC_CHECK_OCLOCK, m_bOClock);
	DDX_Check(pDX, IDC_CHECK_SLEEP, m_bSleep);
	DDX_Check(pDX, IDC_CHECK_TEST, m_bTestMode);
	DDX_CBIndex(pDX, IDC_COMBO_TIME_FROM, m_nSleepTimeFrom);
	DDX_CBIndex(pDX, IDC_COMBO_TIME_TO, m_nSleepTimeTo);
	DDX_Check(pDX, IDC_CHECK_HIGH_VOLUME, m_bHighVolume);
	DDX_Check(pDX, IDC_CHECK_MANNER_APPLY, m_bMannerModeApply);
	DDX_Check(pDX, IDC_CHECK_LOG, m_bLogMode);
	DDX_Check(pDX, IDC_CHECK_POWER_DOWN, m_bPowerDown);
	//}}AFX_DATA_MAP
}

BOOL COnTimeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COnTimeView diagnostics

#ifdef _DEBUG
void COnTimeView::AssertValid() const
{
	CFormView::AssertValid();
}

void COnTimeView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

COnTimeDoc* COnTimeView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COnTimeDoc)));
	return (COnTimeDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COnTimeView message handlers

void COnTimeView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	readInitValue();
	UpdateData(FALSE);
	m_bOClock1   = m_bOClock;
	m_bTestMode1 = m_bTestMode;
	m_bLogMode1  = m_bLogMode;
}

void COnTimeView::OnButtonSet() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	writeInitValue();	

	((COnTimeApp*)AfxGetApp())->m_bOClock			= m_bOClock;
	((COnTimeApp*)AfxGetApp())->m_bSleep			= m_bSleep;
	((COnTimeApp*)AfxGetApp())->m_bTestMode			= m_bTestMode;
	((COnTimeApp*)AfxGetApp())->m_nSleepTimeFrom	= m_nSleepTimeFrom;
	((COnTimeApp*)AfxGetApp())->m_nSleepTimeTo		= m_nSleepTimeTo;
	((COnTimeApp*)AfxGetApp())->m_bHighVolume		= m_bHighVolume;
	((COnTimeApp*)AfxGetApp())->m_bMannerModeApply	= m_bMannerModeApply;
	((COnTimeApp*)AfxGetApp())->m_bLogMode			= m_bLogMode;
	((COnTimeApp*)AfxGetApp())->m_bPowerDown		= m_bPowerDown;

//	for (int i = 0; i < 100; i++)
		((COnTimeApp*)AfxGetApp())->setNextEvent();

	PostQuitMessage(0);
}

void COnTimeView::OnButtonQuit() 
{
	// TODO: Add your control notification handler code here
	((COnTimeApp*)AfxGetApp())->m_bOClock	= m_bOClock1;
	((COnTimeApp*)AfxGetApp())->m_bTestMode = m_bTestMode1;
	((COnTimeApp*)AfxGetApp())->m_bLogMode  = m_bLogMode1;
	((COnTimeApp*)AfxGetApp())->setNextEvent();
	PostQuitMessage(0);
}


//  о´.
void COnTimeView::readInitValue()
{
	HKEY hKey;
	DWORD dwData, dwLen = sizeof(dwData);
	
	if (RegOpenKeyEx( HKEY_LOCAL_MACHINE, _T("Software\\BigBrother\\OnTime"), 0, 0, &hKey) != ERROR_SUCCESS)
		return;

	if (RegQueryValueEx(hKey, _T("OCLOCK_BOOL"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bOClock = TRUE;
		else				m_bOClock = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("SLEEP_MODE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bSleep = TRUE;
		else				m_bSleep = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("TEST_MODE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bTestMode = TRUE;
		else				m_bTestMode = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("LOG_MODE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bLogMode = TRUE;
		else				m_bLogMode = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("POWER_DOWN"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bPowerDown = TRUE;
		else				m_bPowerDown = FALSE;
	}

	if (RegQueryValueEx(hKey, _T("HIGH_VOLUME"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bHighVolume = TRUE;
		else				m_bHighVolume = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("MANNER_MODE"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
	{
		if (dwData == 1)	m_bMannerModeApply = TRUE;
		else				m_bMannerModeApply = FALSE;
	}
	if (RegQueryValueEx(hKey, _T("SLEEP_TIME_FROM"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
		m_nSleepTimeFrom = dwData;
	if (RegQueryValueEx(hKey, _T("SLEEP_TIME_TO"), NULL, NULL,(unsigned char*)&dwData, &dwLen) == ERROR_SUCCESS)
		m_nSleepTimeTo = dwData;

	RegCloseKey(hKey);
}

//  Ѵ.
void COnTimeView::writeInitValue()
{
	HKEY hKey         = 0;
	DWORD dwData      = 0;
	DWORD dwLastError = 0; 	

	dwLastError = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\BigBrother\\OnTime"), 0, 0, &hKey);
	if (dwLastError != ERROR_SUCCESS)
	{
		 dwLastError = RegCreateKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\BigBrother\\OnTime"), 0, NULL, 
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL);
	}
	if (dwLastError != ERROR_SUCCESS)
	{
		AfxMessageBox(_T("   ϴ.")); 
		return;
	}


	dwData = (m_bOClock == TRUE) ? 1 : 0;
	RegSetValueEx(hKey, _T("OCLOCK_BOOL"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));

	dwData = (m_bSleep == TRUE) ? 1 : 0;
	RegSetValueEx(hKey, _T("SLEEP_MODE"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));

	dwData = (m_bTestMode == TRUE) ? 1 : 0;
	RegSetValueEx(hKey, _T("TEST_MODE"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));

	dwData = (m_bLogMode == TRUE) ? 1 : 0;
	RegSetValueEx(hKey, _T("LOG_MODE"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));

	dwData = (m_bPowerDown == TRUE) ? 1 : 0;
	RegSetValueEx(hKey, _T("POWER_DOWN"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));



	dwData = (m_bHighVolume == TRUE) ? 1 : 0;
	RegSetValueEx(hKey, _T("HIGH_VOLUME"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));

	dwData = (m_bMannerModeApply == TRUE) ? 1 : 0;
	RegSetValueEx(hKey, _T("MANNER_MODE"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));

	dwData = m_nSleepTimeFrom;
	RegSetValueEx(hKey, _T("SLEEP_TIME_FROM"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));
	dwData = m_nSleepTimeTo;
	RegSetValueEx(hKey, _T("SLEEP_TIME_TO"), 0, REG_DWORD, (unsigned char*)&dwData, sizeof(dwData));

	RegCloseKey(hKey);
}

